#ifdef GL_ES//for discriminate GLES & GL
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#else
#define highp
#define mediump
#define lowp
#endif

varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;
uniform sampler2D inputImageTexture4;
uniform sampler2D faceMaskTexture;

uniform lowp float laughLineAlpha;
uniform lowp float brightEyeAlpha;
uniform lowp float removePouchAlpha;
uniform lowp float maxImDiff;

uniform highp vec4 stepSize1;
uniform highp vec4 stepSize2;

lowp vec3 sum;
lowp vec3 sum2;
lowp vec3 color;
highp vec2 step1 = vec2(0.00208, 0.0);
highp vec2 step2 = vec2(0.0, 0.00134);

void main()
{

    lowp vec3 iColor = texture2D(inputImageTexture, textureCoordinate).rgb;
    lowp vec3 faceMaskColor = texture2D(faceMaskTexture, textureCoordinate).rgb;
    color = iColor;
    
    //pouch
    if (faceMaskColor.g < 0.0500) {
        lowp vec3 sumColor = texture2D(inputImageTexture2, textureCoordinate).rgb;
        lowp vec3 sumColor2 = texture2D(inputImageTexture3, textureCoordinate).rgb;
        
        lowp vec3 imDiff;
        sum = sumColor;
        sum2 = sumColor2;
        
        imDiff=clamp((sum2-sum)*1.3+0.03*sum2,0.0,maxImDiff);
        imDiff=min(color+imDiff, 1.0);
        
        color = mix(iColor, imDiff, removePouchAlpha * faceMaskColor.b);
    }
    //bright eye
    else if (faceMaskColor.b < 0.0500) {

        highp vec3 sumColor = iColor;
        sumColor += texture2D(inputImageTexture4,textureCoordinate + (-2.0) * step1).rgb;
        sumColor += texture2D(inputImageTexture4,textureCoordinate +  2.0   * step1).rgb;
        sumColor += texture2D(inputImageTexture4,textureCoordinate + (-2.0) * step2).rgb;
        sumColor += texture2D(inputImageTexture4,textureCoordinate +  2.0   * step2).rgb;
        
        sumColor += texture2D(inputImageTexture4,textureCoordinate + -step1 +  step2).rgb;
        sumColor += texture2D(inputImageTexture4,textureCoordinate + -step1 + -step2).rgb;
        sumColor += texture2D(inputImageTexture4,textureCoordinate +  step1 +  step2).rgb;
        sumColor += texture2D(inputImageTexture4,textureCoordinate +  step1 + -step2).rgb;
        
        sumColor = sumColor * 0.11111;
        sumColor = clamp(sumColor + (color.rgb - sumColor) * 3.0, 0.0, 1.0);
        sumColor = max(color.rgb, sumColor);
        color = mix(color, sumColor, brightEyeAlpha * faceMaskColor.g);
    }
    //laugh line
    else {
        lowp vec3 sumColor = texture2D(inputImageTexture2, textureCoordinate).rgb;
        lowp vec3 sumColor2 = texture2D(inputImageTexture3, textureCoordinate).rgb;
        
        lowp vec3 imDiff;
        sum = sumColor;
        sum2 = sumColor2;
        
        imDiff=clamp((sum2-sum)*1.3+0.03*sum2,0.0,maxImDiff);
        imDiff=min(color+imDiff, 1.0);
        
        color = mix(iColor, imDiff, laughLineAlpha * faceMaskColor.b);
    }
    
    gl_FragColor = vec4(color, 1.0);
}
