#ifdef GL_ES//for discriminate GLES & GL
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#else
#define highp
#define mediump
#define lowp
#endif

varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;
uniform sampler2D lookUpBrightEye;
uniform sampler2D faceMaskTexture;

uniform lowp float laughLineAlpha;
uniform lowp float brightEyeAlpha;
uniform lowp float removePouchAlpha;
uniform lowp float maxImDiff;

uniform highp float stepSize1;
uniform highp float stepSize2;
uniform lowp float brightEyeCurveAlpha;
//highp vec2 step1 = vec2(0.00208, 0.0);
//highp vec2 step2 = vec2(0.0, 0.00167);
uniform lowp float brightEyeSharpenAlpha;

lowp vec3 sum;
lowp vec3 sum2;
lowp vec3 color;
//mediump vec3 gray = (0.299,0.587,0.114);

void main()
{

    lowp vec3 iColor = texture2D(inputImageTexture, textureCoordinate).rgb;
    lowp vec3 faceMaskColor = texture2D(faceMaskTexture, textureCoordinate).rgb;
    color = iColor;
    
    //pouch
    if (faceMaskColor.g < 0.0500) {
        lowp vec3 sumColor = texture2D(inputImageTexture2, textureCoordinate).rgb;
        lowp vec3 sumColor2 = texture2D(inputImageTexture3, textureCoordinate).rgb;
        
        lowp vec3 imDiff;
        sum = sumColor;
        sum2 = sumColor2;
        
        imDiff=clamp((sum2-sum)*1.3+0.03*sum2,0.0,maxImDiff);
        imDiff=min(color+imDiff, 1.0);
        
        color = mix(iColor, imDiff, removePouchAlpha * faceMaskColor.b);
    }
    //bright eye
    else if (faceMaskColor.b < 0.0500) {
        highp vec2 step1 = vec2(stepSize1, 0.0);
        highp vec2 step2 = vec2(0.0, stepSize2);
        highp vec3 sumColor = iColor;
        sumColor += texture2D(inputImageTexture,textureCoordinate + (-2.0) * step1).rgb;
        sumColor += texture2D(inputImageTexture,textureCoordinate +  2.0   * step1).rgb;
        sumColor += texture2D(inputImageTexture,textureCoordinate + (-2.0) * step2).rgb;
        sumColor += texture2D(inputImageTexture,textureCoordinate +  2.0   * step2).rgb;
        
        sumColor += texture2D(inputImageTexture,textureCoordinate + step1).rgb;
        sumColor += texture2D(inputImageTexture,textureCoordinate - step1).rgb;
        sumColor += texture2D(inputImageTexture,textureCoordinate + step2).rgb;
        sumColor += texture2D(inputImageTexture,textureCoordinate - step2).rgb;
        
        sumColor += texture2D(inputImageTexture,textureCoordinate + -step1 +  step2).rgb;
        sumColor += texture2D(inputImageTexture,textureCoordinate + -step1 + -step2).rgb;
        sumColor += texture2D(inputImageTexture,textureCoordinate +  step1 +  step2).rgb;
        sumColor += texture2D(inputImageTexture,textureCoordinate +  step1 + -step2).rgb;
//        sumColor = sumColor * 0.11111;
        sumColor = sumColor * 0.07692;
        highp vec3 sumColor2 = texture2D(inputImageTexture2,textureCoordinate).rgb;
        lowp vec3 stepSumColor = step(0.0,(color.rgb - sumColor2).rgb);
        highp vec3 stepSumColor2 = clamp(5.0 * (color.g + 0.7) * (color.rgb - sumColor2.rgb + 0.1),0.0,1.0);
        stepSumColor2 = mix(stepSumColor2,vec3(1.0,1.0,1.0),stepSumColor);
        sumColor = clamp(sumColor + (color.rgb - sumColor) * brightEyeSharpenAlpha, 0.0, 1.0);
        sumColor = max(color.rgb - 0.05, sumColor);
        highp vec3 sumColorBright = sumColor;
        sumColorBright.r = texture2D(lookUpBrightEye, vec2(sumColor.r, 0.5)).r;
        sumColorBright.g = texture2D(lookUpBrightEye, vec2(sumColor.g, 0.5)).g;
        sumColorBright.b = texture2D(lookUpBrightEye, vec2(sumColor.b, 0.5)).b;
        sumColorBright = mix(sumColor, sumColorBright, brightEyeCurveAlpha * stepSumColor2);
        color = mix(color, sumColorBright, brightEyeAlpha * faceMaskColor.g);
    }
    //laugh line
    else {
        lowp vec3 sumColor = texture2D(inputImageTexture2, textureCoordinate).rgb;
        lowp vec3 sumColor2 = texture2D(inputImageTexture3, textureCoordinate).rgb;
        
        lowp vec3 imDiff;
        sum = sumColor;
        sum2 = sumColor2;
        
        imDiff=clamp((sum2-sum)*1.3+0.03*sum2,0.0,maxImDiff);
        imDiff=min(color+imDiff, 1.0);
        
        color = mix(iColor, imDiff, laughLineAlpha * faceMaskColor.b);
    }
    
    gl_FragColor = vec4(color, 1.0);
}
