//
//  EditEnhance_f.shader
//  BeautyPlus
//
//  Created by Webster Wu on 2/18/16.
//  Copyright © 2016 美图网. All rights reserved.
//

precision highp float;

// texture to draw
uniform lowp sampler2D inputImageTexture0;

uniform lowp sampler2D blurredPreviewTexture;

uniform float SmartContrast;

// current position
varying vec2 texcoordOut;

vec3 overlay(const in vec3 lowerColor, const in vec3 upperColor) {
    // lowerChannel > 0.5 ==> stepEdge = 1.0 else 0.0
    vec3 stepEdge = step(0.5, lowerColor);  // lowerColor > 0.5 ? 1 : 0
    vec3 inverseStepEdge = -stepEdge * 2.0 + 1.0;  // lowerColor > 0.5 ? -1 : 1

    vec3 common = inverseStepEdge * (2.0 * lowerColor * upperColor);
    vec3 preAndMinValue = stepEdge * ((2. * upperColor) + (lowerColor - (1.0 - lowerColor)));

    return common + preAndMinValue;
}


void main() {
    // Sample colors.
    vec3 color = texture2D(inputImageTexture0, texcoordOut).rgb;

    vec3 blurColor =  texture2D(blurredPreviewTexture, texcoordOut).rgb;

    // Ambiance.
    vec3 J = overlay(color, blurColor);
    vec3 newColor = mix(color, J, SmartContrast);


    // Assign to framebuffer.
    gl_FragColor.rgb = newColor;
    gl_FragColor.a = 1.;
}
