//
//  EditEnhance_f.shader
//  BeautyPlus
//
//  Created by Webster Wu on 2/18/16.
//  Copyright © 2016 美图网. All rights reserved.
//

precision highp float;
varying highp vec2 texcoordOut;
uniform sampler2D inputImageTexture0;
uniform sampler2D guassFrame;
uniform lowp float Shadow;
uniform lowp float Highlight;
uniform lowp vec3 redShift;
uniform lowp vec3 orangeShift;
uniform lowp vec3 yellowShift;
uniform lowp vec3 greenShift;
uniform lowp vec3 aquaShift;
uniform lowp vec3 blueShift;
uniform lowp vec3 purpleShift;
uniform lowp vec3 magentaShift;
uniform lowp vec4 ShadowColor;
uniform lowp vec4 MiddleColor;
uniform lowp vec4 HighlightColor;


const lowp vec3 lumCoeff=vec3(0.2125,0.7154,0.0721);


mediump vec3 getSelectiveColorWhite(mediump vec3 baseColor,mediump float iMin,mediump float iMid,mediump float iMax,mediump vec3 disCMY, mediump float Cv,mediump float Mv,mediump float Yv,mediump float Bv,mediump float isRelative)
{
mediump float r,g,b;
mediump vec3 result=disCMY;

if ((baseColor.r > 0.5)&&(baseColor.g > 0.5)&&(baseColor.b > 0.5))
{
mediump float iLim=abs((iMin-0.5)*2.0);

//follow is same
mediump float iInc,iDec,disC,disM,disY,iValue;
disC=disCMY.x;
disM=disCMY.y;
disY=disCMY.z;

if (Cv!=0.0)
{
iInc=(iLim*baseColor.r);
iDec=iLim-iInc;
if ((isRelative > 0.0)&&(baseColor.r > 0.5))
iInc=iDec;
iValue=Cv > 0.0?(iInc*Cv):(iDec*Cv);
disC=disC+iValue;
}

if (Mv!=0.0)
{
iInc=(iLim*baseColor.g);
iDec=iLim-iInc;
if ((isRelative > 0.0)&&(baseColor.g > 0.5))
iInc=iDec;
iValue=Mv > 0.0?(iInc*Mv):(iDec*Mv);
disM=disM+iValue;
}

if (Yv!=0.0)
{
iInc=iLim*baseColor.b;
iDec=iLim-iInc;
if ((isRelative > 0.0)&&(baseColor.b > 0.5))
iInc=iDec;
iValue=Yv > 0.0?(iInc*Yv):(iDec*Yv);
disY=disY+iValue;
}

result=vec3(disC,disM,disY);
}

return result;
}

//8.Selective Color Gray
mediump vec3 getSelectiveColorGray(mediump vec3 baseColor,mediump float iMin,mediump float iMid,mediump float iMax,mediump vec3 disCMY, mediump float Cv,mediump float Mv,mediump float Yv,mediump float Bv,mediump float isRelative)
{
mediump float r,g,b;
mediump vec3 result=disCMY;

if (!((baseColor.r==0.0) && (baseColor.g==0.0) && (baseColor.b==0.0)||(baseColor.r==1.0) && (baseColor.g==1.0) && (baseColor.b==1.0)))
{
mediump float iLim=abs(1.0-(abs(iMax-0.5)+abs(iMin-0.5)));

//follow is same
mediump float iInc,iDec,disC,disM,disY,iValue;
disC=disCMY.x;
disM=disCMY.y;
disY=disCMY.z;

if (Cv!=0.0)
{
iInc=(iLim*baseColor.r);
iDec=iLim-iInc;
if ((isRelative>0.0) && (baseColor.r>0.5))
iInc=iDec;
iValue=Cv>0.0?(iInc*Cv):(iDec*Cv);
disC=disC+iValue;
}

if (Mv!=0.0)
{
iInc=(iLim*baseColor.g);
iDec=iLim-iInc;
if ((isRelative>0.0) && (baseColor.g>0.5))
iInc=iDec;
iValue=Mv>0.0?(iInc*Mv):(iDec*Mv);
disM=disM+iValue;
}

if (Yv!=0.0)
{
iInc=iLim*baseColor.b;
iDec=iLim-iInc;
if ((isRelative>0.0) && (baseColor.b>0.5))
iInc=iDec;
iValue=Yv>0.0?(iInc*Yv):(iDec*Yv);
disY=disY+iValue;
}

result=vec3(disC,disM,disY);
}

return result;
}

//9.Selective Color Black
mediump vec3 getSelectiveColorBlack(mediump vec3 baseColor,mediump float iMin,mediump float iMid,mediump float iMax,mediump vec3 disCMY, mediump float Cv,mediump float Mv,mediump float Yv,mediump float Bv,mediump float isRelative)
{
mediump float r,g,b;
mediump vec3 result=disCMY;

if ((baseColor.r < 0.5)&&(baseColor.g < 0.5)&&(baseColor.b < 0.5))
{
mediump float iLim=(0.5-iMax)*2.0;

//follow is same
mediump float iInc,iDec,disC,disM,disY,iValue;
disC=disCMY.x;
disM=disCMY.y;
disY=disCMY.z;

if (Cv!=0.0)
{
iInc=(iLim*baseColor.r);
iDec=iLim-iInc;
if ((isRelative > 0.0)&&(baseColor.r > 0.5))
iInc=iDec;
iValue=Cv > 0.0?(iInc*Cv):(iDec*Cv);
disC=disC+iValue;
}

if (Mv!=0.0)
{
iInc=(iLim*baseColor.g);
iDec=iLim-iInc;
if ((isRelative > 0.0)&&(baseColor.g > 0.5))
iInc=iDec;
iValue=Mv > 0.0?(iInc*Mv):(iDec*Mv);
disM=disM+iValue;
}

if (Yv!=0.0)
{
iInc=iLim*baseColor.b;
iDec=iLim-iInc;
if ((isRelative > 0.0)&&(baseColor.b > 0.5))
iInc=iDec;
iValue=Yv > 0.0?(iInc*Yv):(iDec*Yv);
disY=disY+iValue;
}

result=vec3(disC,disM,disY);
}

return result;
}


vec3 rgb2hsv(vec3 rgb)
{
float rc = rgb.r;
float gc = rgb.g;
float bc = rgb.b;

float h = 0.0;
float s = 0.0;
float v = 0.0;

float max_v = max(rc, max(gc, bc));
float min_v = min(rc, min(gc, bc));
float delta = max_v - min_v;

v = max_v;

if (max_v != 0.0) {
s = delta / max_v;
} else {
s = 0.0;
}

if (s == 0.0) {
h = 0.0;
} else {
if (rc == max_v) {
h = (gc - bc) / delta;
} else if (gc == max_v) {
h = 2.0 + (bc - rc) / delta;
} else if (bc == max_v) {
h = 4.0 + (rc - gc) / delta;
}

h *= 60.0;
if (h < 0.0) {
h += 360.0;
}
}

return vec3(h,s,v);

}


vec3 hsv2rgb(vec3 rgb)
{
float h, s,v;
float r, g, b;

h=rgb.r;
s=rgb.g;
v=rgb.b;
int i = 0;
float f, p, q, t;
if( s == 0.0 ) {
// achromatic (grey)
r = g = b = v;
} else {
h /= 60.0;            // sector 0 to 5
i = int(floor( h ));
f = h - float(i);            // factorial part of h
p = v * ( 1.0 - s );
q = v * ( 1.0 - s * f );
t = v * ( 1.0 - s * ( 1.0 - f ) );

if (i == 0) {
r = v;
g = t;
b = p;
} else if (i == 1) {
r = q;
g = v;
b = p;
} else if (i == 2) {
r = p;
g = v;
b = t;
} else if (i == 3) {
r = p;
g = q;
b = v;
} else if (i == 4) {
r = t;
g = p;
b = v;

} else {
r = v;
g = p;
b = q;
}
}
return vec3(r,g,b);
}

vec3 hueAdjust(vec3 hsb,vec3 maskHsb,float standHue,float deltaRange,vec3 hueParam,float offset)
{
if ((hueParam.x==0.0) &&(hueParam.y==0.0) &&(hueParam.z==0.0))
return hsb;
//hsb adjust
vec3 tmpHSB;
float fAlpha;
float standHue0,minHue,maxHue,currHue;
//Red
hueParam.x=hueParam.x*30.0/100.0;
hueParam.y=hueParam.y*0.8/100.0;
hueParam.z=hueParam.z/100.0;

//init data
standHue0=standHue+offset;
minHue=standHue0-deltaRange;
maxHue=standHue0+deltaRange;
tmpHSB=hsb;
//check range

if (offset>0.0)
{
if (maskHsb.r>180.0)
currHue=maskHsb.r-360.0+offset;
else
currHue=maskHsb.r+offset;
}
else
currHue=maskHsb.r;
if ((currHue>=minHue) && (currHue <= maxHue))
{
//get alpha
fAlpha=abs(currHue-standHue0);
//fAlpha=1.0-fAlpha/deltaRange;
fAlpha=1.0-fAlpha/deltaRange;

//hue
tmpHSB.x=hsb.r+hueParam.x*fAlpha;
if (tmpHSB.x>360.0)
tmpHSB.x=tmpHSB.x-360.0;
//saturation
tmpHSB.y=hsb.y+hsb.y*hueParam.y*fAlpha;
tmpHSB.y=clamp(tmpHSB.y,0.0,1.0);
//bright
tmpHSB.z=hsb.z+hsb.z*hsb.y*hueParam.z*fAlpha;
//tmpHSB.z=hsb.z+hsb.z*hsb.y*hueParam.z*0.5; //


tmpHSB.z=clamp(tmpHSB.z,0.0,1.0);
}

return tmpHSB;
}

mediump float BlendSoftLightf(mediump float base,mediump float blend)
{
mediump float fValue=base;
if (blend < 0.5)
fValue=base * blend*2.0 + base * base * (1.0 - 2.0 * blend);
else
fValue=sqrt(base) * (2.0 * blend - 1.0) + 2.0 * base * (1.0 - blend);
return fValue;
}


mediump vec3 blendSoftLight(mediump vec3 base,mediump vec3 blend)
{
mediump vec3 result;
result.r=BlendSoftLightf(base.r,blend.r);
result.g=BlendSoftLightf(base.g,blend.g);
result.b=BlendSoftLightf(base.b,blend.b);
return result;
}

float getFixValue(float value,float x1,float x2)
{
float retValue=value;
if (value < 0.0)
retValue=value*abs(x1);
else
retValue=value*x2;

return retValue;
}

vec4 getFixColorRange(vec4 cr,vec2 fixR,vec2 fixG,vec2 fixB)
{
vec4 retColor=cr;
retColor.r=getFixValue(cr.r,fixR.x,fixR.y);
retColor.g=getFixValue(cr.g,fixG.x,fixG.y);
retColor.b=getFixValue(cr.b,fixB.x,fixB.y);
return retColor;
}




void main()
{
if ((redShift.x==0.0) &&(redShift.y==0.0) &&(redShift.z==0.0)) {
    gl_FragColor=vec4(1.0,0.0,0.0,1.0);
    return;
}

mediump vec3 clO,clA,clB,clC,clBlur,clTmp,clGuass;
mediump float lum,fTmp,alpha;
mediump float result,base,blend;

mediump vec4 baseColor=texture2D(inputImageTexture0, texcoordOut);
clGuass=texture2D(guassFrame, texcoordOut).rgb;
//clGuass=baseColor.rgb;
clO=baseColor.rgb;
clA=clO;

//////////

//Highlight and Shadow
mediump float fTmpGamma;
mediump float lumBlur=dot(clO,lumCoeff);
lumBlur=lumBlur*2.0-1.0;
/*
if (lumBlur < 0.0)
{// sharpeness
mediump float imageWidthFactor=1.0/ImageSize.x;
mediump float imageHeightFactor=1.0/ImageSize.y;
imageWidthFactor=min(imageWidthFactor,0.0011);
imageHeightFactor=min(imageHeightFactor,0.0011);

mediump vec2 widthStep = vec2(imageWidthFactor, 0.0);
mediump vec2 heightStep = vec2(0.0, imageHeightFactor);


mediump vec2 lefttexcoordOut = texcoordOut.xy - widthStep;
mediump vec2 righttexcoordOut = texcoordOut.xy + widthStep;
mediump vec2 toptexcoordOut = texcoordOut.xy + heightStep;
mediump vec2 bottomtexcoordOut = texcoordOut.xy - heightStep;

mediump float centerMultiplier = 1.0 + 4.0 * sharpness;
mediump float edgeMultiplier = sharpness;

mediump vec3 textureColor = baseColor.rgb;
mediump vec3 leftTextureColor = texture2D(inputImageTexture0, lefttexcoordOut).rgb;
mediump vec3 rightTextureColor = texture2D(inputImageTexture0, righttexcoordOut).rgb;
mediump vec3 topTextureColor = texture2D(inputImageTexture0, toptexcoordOut).rgb;
mediump vec3 bottomTextureColor = texture2D(inputImageTexture0, bottomtexcoordOut).rgb;

clA = vec3((textureColor * centerMultiplier - (leftTextureColor * edgeMultiplier + rightTextureColor * edgeMultiplier + topTextureColor * edgeMultiplier + bottomTextureColor * edgeMultiplier)));
}
clA=clO;*/

if (lumBlur < 0.0)
{
mediump float factor = 1.0;
if(Shadow > 0.0)
{
factor = 0.9;
}
else
{
factor=1.3;
}
fTmpGamma = pow(10.0, abs(lumBlur) * Shadow/200.0*factor);
clA=vec3(1.0 - pow(vec3(1.0 - clO), vec3(fTmpGamma)));
}
else
//Highlight
{
mediump float factor = 1.0;
if(Highlight < 0.0)
{
factor = 0.9;
}
else
{
factor=1.3;
}
fTmpGamma=pow(10.0, abs(lumBlur) * (-Highlight/200.0) * factor);
clA=pow(clO,vec3(fTmpGamma));
}
/////////////


vec3 hsb=rgb2hsv(clA);
vec3 hsbGuass=rgb2hsv(clGuass);

/*
//Highlight and Shadow
mediump float fTmpGamma;
mediump float fLight=hsb.z;
mediump float lumBlur=hsbGuass.z;

lumBlur=lumBlur*2.0-1.0;


if (lumBlur < 0.0)
{
fTmpGamma = pow(2.0, abs(lumBlur) * Shadow*0.04);
fLight=1.0 - pow(1.0 - fLight, fTmpGamma);
}
//else
//Highlight
{
fTmpGamma=pow(2.0, abs(lumBlur+1.0) * (-0.01)*Highlight);
fLight=pow(fLight,fTmpGamma);
}

hsb.z=clamp(fLight,0.0,100.0);*/

//balance color

mediump vec4 ShadowColor0;
mediump vec4 MiddleColor0;
mediump vec4 HighlightColor0;
HighlightColor0=getFixColorRange(HighlightColor,vec2(-1.0,0.5),vec2(-1.0,0.4),vec2(-1.0,0.5));
MiddleColor0=getFixColorRange(MiddleColor,vec2(-0.7,0.6),vec2(-0.5,0.5),vec2(-0.6,0.8));
ShadowColor0=getFixColorRange(ShadowColor,vec2(-0.7,1.0),vec2(-0.5,1.0),vec2(-0.5,1.0));

//Selective
clA=hsv2rgb(hsb);

mediump vec3 disCMY,baseColor1;
mediump float iMin,iMid,iMax,isRelative;
baseColor1=clA.rgb;
disCMY=vec3(0.0,0.0,0.0);
isRelative=1.0;   //true--1.0   false--0.0
iMin=min(baseColor1.r,min(baseColor1.g,baseColor1.b));
iMax=max(baseColor1.r,max(baseColor1.g,baseColor1.b));
iMid=iMin;
if ((baseColor1.r > iMin)&&(baseColor1.r < iMax)) iMid=baseColor1.r;
else
if ((baseColor1.g > iMin)&&(baseColor1.g < iMax)) iMid=baseColor1.g;
else
if ((baseColor1.b > iMin)&&(baseColor1.b < iMax)) iMid=baseColor1.b;
disCMY=getSelectiveColorWhite(baseColor1,iMin,iMid,iMax,disCMY,HighlightColor0.x/100.0,HighlightColor0.y/100.0,HighlightColor0.z/100.0,0.0,HighlightColor.w);
disCMY=getSelectiveColorGray(baseColor1,iMin,iMid,iMax,disCMY,MiddleColor0.x/100.0,MiddleColor0.y/100.0,MiddleColor0.z/100.0,0.0,MiddleColor.w);
disCMY=getSelectiveColorBlack(baseColor1,iMin,iMid,iMax,disCMY,ShadowColor0.x/100.0,ShadowColor0.y/100.0,ShadowColor0.z/100.0,0.0,ShadowColor.w);
clA.r=clamp(baseColor1.r-disCMY.x,0.0,1.0);
clA.g=clamp(baseColor1.g-disCMY.y,0.0,1.0);
clA.b=clamp(baseColor1.b-disCMY.z,0.0,1.0);

hsb=rgb2hsv(clA);

//hsb adjust
hsbGuass=hsb;
//red
hsb=hueAdjust(hsb,hsbGuass,0.0,30.0,redShift,360.0);
//orangeShift
hsb=hueAdjust(hsb,hsbGuass,15.0,30.0,orangeShift,360.0);
//yellowShift
hsb=hueAdjust(hsb,hsbGuass,50.0,50.0,yellowShift,0.0);
//greenShift
hsb=hueAdjust(hsb,hsbGuass,120.0,60.0,greenShift,0.0); // before standH=120.0
//aquaShift
hsb=hueAdjust(hsb,hsbGuass,180.0,20.0,aquaShift,0.0);
//blueShift
hsb=hueAdjust(hsb,hsbGuass,240.0,60.0,blueShift,0.0);
//purpleShift
hsb=hueAdjust(hsb,hsbGuass,300.0,40.0,purpleShift,0.0);
//magentaShift
hsb=hueAdjust(hsb,hsbGuass,330.0,20.0,magentaShift,0.0);


clA=hsv2rgb(hsb);
gl_FragColor=vec4(clA,baseColor.a);
}
